# Gridlock - a collection of grid-based strategy games
# Copyright (c) 2009 Brian Nenninger (brian@dozingcatsoftware.com)
# Gridlock comes with ABSOLUTELY NO WARRANTY, and is released under version 3 of the GNU GPL.

import GridUtils
from Game import GameState
from GenericAI import GenericAI
import LineGame

class GomokuGameState (LineGame.LineGameState): 
    def successors(self):
        for c in self.enumerate_coords_with_value(0):
            nextgrid = self.grid.copy()
            nextgrid[c] = self.current_player
            yield ( (c,), self.next_state_with_grid(nextgrid) )
            
    def win_length(self):
        return 5
            
NEXT_PLAYER_WEIGHTS = [0,0, 1,5, 10,50, 100,500, 1000,50000, 9999999,9999999]
CURRENT_PLAYER_WEIGHTS = [0,0, 1,5, 10,50, 500,2500, 999999,999999, 9999999,9999999]
            
class GomokuAI (GenericAI):
    def game_utility(self, gstate):
        return LineGame.threat_weight(gstate, gstate.current_player, CURRENT_PLAYER_WEIGHTS) - \
               LineGame.threat_weight(gstate, gstate.next_player(), NEXT_PLAYER_WEIGHTS)
            
